//+------------------------------------------------------------------+ 
//| Cycles.mq4 | 
//| FCognet | 
//| | 
//+------------------------------------------------------------------+ 
#property copyright "Eric Lefort" 
#property link "http://www.pro-at.com" 

#property indicator_separate_window 
#property indicator_buffers 1 
#property indicator_color1 Gold 

//---- buffers 
double Cycle[]; 


double STPMT[]; 
double STPMT_MA[]; 


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() { 
string short_name; 
short_name="Cycles"; 
IndicatorShortName(short_name); 
//---- indicators 



IndicatorBuffers(3); 


SetIndexBuffer(0, Cycle); 
SetIndexBuffer(1, STPMT); 
SetIndexBuffer(2, STPMT_MA); 


SetIndexStyle(0, DRAW_LINE,0, 3); 


//--- trac de droite horizontale 
SetLevelValue(0,0); 
SetLevelStyle(STYLE_DASHDOTDOT,0,Magenta); 



//---- 
return(0); 
} 

//+------------------------------------------------------------------+ 
//| iteration function | 
//+------------------------------------------------------------------+ 
int start() { 

double A,B,C,D ; 

int index = 0; 
int counted_bars=IndicatorCounted(); 

int limit = Bars - counted_bars; 

for(index=0;index<limit;index++) { 
A = iStochastic( NULL, 0, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, index); 
B = iStochastic( NULL, 0, 14, 3, 3, MODE_SMA, 0, MODE_SIGNAL, index); 
C = iStochastic( NULL, 0, 45, 14, 3, MODE_SMA, 0, MODE_SIGNAL, index); 
C = iStochastic( NULL, 0, 75, 20, 3, MODE_SMA, 0, MODE_SIGNAL, index); 
STPMT[index] = (4.1 * A + 2.5 * B + C + 4 * C) / 11.6; 


} 
for(index=0;index<limit;index++) { 
STPMT_MA[index] = iMAOnArray(STPMT, 0, 9, 0, MODE_SMA, index); 
Cycle[index] = STPMT[index] - STPMT_MA[index]; 
} 
return(0); 
} 